#heavy Knight maxidonis
effect give @e[tag=maxidonis_Entity] invisibility 999999 0 true
execute as @e[tag=maxidonis_Entity,tag=!invulnerable_phase] at @s unless entity @e[tag=maxidonis_Model,distance=..2] run function dual_wield_hero:summon/default
execute as @e[tag=maxidonis_Entity] at @s unless entity @e[tag=maxidonis_name,distance=..3] run summon armor_stand ~ ~2 ~ {NoGravity:1b,Marker:1b,Invisible:true,CustomName:'[{"text":"Capital Banneret Maxidonis","bold":true,"color":"red"}]',CustomNameVisible:1b,Tags:["maxidonis_name"]}
execute as @e[tag=maxidonis_Model] at @s run tp @e[tag=maxidonis_name,limit=1,sort=nearest] ~ ~2 ~

execute as @e[tag=maxidonis_Entity,tag=!invulnerable_phase] at @s if entity @e[type=#enemy,distance=..20] run tp @e[tag=maxidonis_Model,sort=nearest,limit=1] ^ ^ ^ facing entity @e[type=#enemy,sort=nearest,distance=..10,limit=1]
execute as @e[tag=maxidonis_Entity,tag=!invulnerable_phase] at @s unless entity @e[type=#enemy,distance=..20] run tp @e[tag=maxidonis_Model,sort=nearest,limit=1] ^ ^ ^

execute as @e[tag=maxidonis_Model] at @s unless entity @e[tag=maxidonis_Entity,distance=..2] run function dual_wield_hero:remove/this
execute as @e[tag=maxidonis_Model] at @s unless entity @e[tag=maxidonis_cd_marker,distance=..700] run particle dust_color_transition 1 0 0 1 0.3 0 0 ~ ~2.5 ~ 0 0 0 0.2 1 force
execute as @e[tag=maxidonis_Entity] at @s unless entity @e[tag=maxidonis_dd] run summon area_effect_cloud ~ ~ ~ {Duration:2147483647,Tags:["maxidonis_dd","hero_dd"]}

#reset pose
execute as @e[tag=maxidonis_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=0..10}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Sir Maxidonis","bold":true,"color":"green"},{"text":"> You should never let your guard down, ","color":"white"},{"selector":"@p","color":"white"},{"text":".","color":"white"}]
execute as @e[tag=maxidonis_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=11..20}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Sir Maxidonis","bold":true,"color":"green"},{"text":"> Remember to watch your blind sides, ","color":"white"},{"selector":"@p","color":"white"},{"text":".","color":"white"}]
execute as @e[tag=maxidonis_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4,scores={ally.anim_tick=21..30}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Sir Maxidonis","bold":true,"color":"green"},{"text":"> Do you need any intel, ","color":"white"},{"selector":"@p","color":"white"},{"text":"?","color":"white"}]
execute as @e[tag=maxidonis_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run tp @s ~ ~ ~ facing entity @p[distance=..4,limit=1,gamemode=!spectator]
execute as @e[tag=maxidonis_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run effect give @s slowness 1 255 true
execute as @e[tag=maxidonis_Entity] at @s unless entity @e[type=#enemy,distance=..20] if entity @p[distance=..4] run tag @s add greeted_player
execute as @e[tag=maxidonis_Entity] at @s unless entity @e[type=#enemy,distance=..20] unless entity @p[distance=..10] run tag @s remove greeted_player

#hurt
execute as @e[tag=maxidonis_Entity,tag=hurt,tag=!invulnerable_phase] at @s run playsound entity.generic.hurt neutral @a[distance=..5] ~ ~ ~ 1 1 0
execute as @e[tag=maxidonis_Entity,tag=hurt,tag=!invulnerable_phase] at @s run particle angry_villager ~ ~1.5 ~ 0.3 0.3 0.3 0 3 normal
#execute as @e[tag=maxidonis_Entity,tag=hurt,tag=!invulnerable_phase] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=0..10}] ["",{"text":"<","color":"white"},{"text":"Sir Maxidonis","bold":true,"color":"green"},{"text":"> Tch! aren't you a sharp one.","color":"white"}]
#execute as @e[tag=maxidonis_Entity,tag=hurt,tag=!invulnerable_phase] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=11..20}] ["",{"text":"<","color":"white"},{"text":"Sir Maxidonis","bold":true,"color":"green"},{"text":"> Hrngh!","color":"white"}]
#execute as @e[tag=maxidonis_Entity,tag=hurt,tag=!invulnerable_phase] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=21..30}] ["",{"text":"<","color":"white"},{"text":"Sir Maxidonis","bold":true,"color":"green"},{"text":"> On me!","color":"white"}]
#Attacking
execute as @e[tag=maxidonis_Model] at @s if entity @e[type=#enemy,distance=..4,tag=hurt] if entity @p[scores={ally.anim_tick=0..10}] run function dual_wield_hero:animations/ds_attack_1/play
execute as @e[tag=maxidonis_Model] at @s if entity @e[type=#enemy,distance=..4,tag=hurt] if entity @p[scores={ally.anim_tick=11..20}] run function dual_wield_hero:animations/ds_attack_2/play
execute as @e[tag=maxidonis_Model] at @s if entity @e[type=#enemy,distance=..4,tag=hurt] if entity @p[scores={ally.anim_tick=21..30}] run function dual_wield_hero:animations/ds_attack_3/play


execute as @e[tag=maxidonis_Model] at @s if entity @e[type=#enemy,distance=..4,tag=hurt] run particle sweep_attack ^0.5 ^1 ^1.5 0.1 0.1 0.1 0 1 normal
execute as @e[tag=maxidonis_Model] at @s if entity @e[type=#enemy,distance=..4,tag=hurt] run particle sweep_attack ^0.5 ^1 ^1.5 0.1 0.1 0.1 0 1 normal
execute as @e[tag=maxidonis_Model] at @s if entity @e[type=#enemy,distance=..4,tag=hurt] run playsound entity.player.attack.sweep neutral @a[distance=..10] ~ ~ ~ 1 1 0

#walking animation
execute as @e[tag=maxidonis_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=maxidonis_Model] if entity @e[type=#enemy,distance=..20] run function dual_wield_hero:animations/walking_offensive/next_frame
execute as @e[tag=maxidonis_Entity,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=maxidonis_Model] unless entity @e[type=#enemy,distance=..20] run function dual_wield_hero:animations/walk_idle/next_frame
execute as @e[tag=maxidonis_Entity,nbt={Motion:[0.0d,0.0d,0.0d]}] at @s unless entity @e[type=#enemy,distance=..10,tag=!hurt] run execute as @e[limit=1,sort=nearest,tag=maxidonis_Model] run function dual_wield_hero:animations/idle/next_frame

#Phantom Assault chance and particles and effects , nbt={ActiveEffects:[{Id:5b}]}
execute as @e[tag=maxidonis_Entity] at @s unless entity @e[tag=maxidonis_cd_marker,distance=..700] if entity @e[type=#enemy,distance=..20] run function ampsurv:entity/ally/maxidonis-pa

execute as @e[tag=maxidonis_Entity,nbt={ActiveEffects:[{Id:5b}]}] at @s run execute as @e[tag=aj.dual_wield_hero.bone.sword,limit=1,sort=nearest] at @s positioned ~ ~ ~ run particle dust_color_transition 1 0 0 1 0.3 0 0 ^ ^1 ^0.5 0.2 0.2 0.2 0.1 1 force
execute as @e[tag=maxidonis_Entity,nbt={ActiveEffects:[{Id:5b}]}] at @s run execute as @e[tag=aj.dual_wield_hero.bone.sword3,limit=1,sort=nearest] at @s positioned ~ ~ ~ run particle dust_color_transition 1 0 0 1 0.3 0 0 ^ ^1 ^0.5 0.2 0.2 0.2 0.1 1 force
execute as @e[tag=maxidonis_Entity,nbt={ActiveEffects:[{Id:5b}]}] at @s run execute as @e[tag=maxidonis_Model,limit=1,sort=nearest] at @s anchored feet run particle dust_color_transition 1 0 0 2 0.3 0 0 ~ ~0.3 ~ 0.3 0.3 0.3 0.2 1 force

execute as @e[tag=maxidonis_Entity,tag=phantom_assault_on,tag=!invulnerable_phase] at @s unless entity @e[tag=maxidonis_tp_marker,distance=..700] run playsound entity.illusioner.cast_spell neutral @a[distance=..10] ~ ~ ~ 1 0 0.2
execute as @e[tag=maxidonis_Entity,tag=phantom_assault_on,tag=!invulnerable_phase] at @s unless entity @e[tag=maxidonis_tp_marker,distance=..700] run tellraw @a[distance=..15] ["",{"text":"<","color":"white"},{"text":"Sir Maxidonis","bold":true,"color":"light_purple"},{"text":"> My shadows will protect me.. ","color":"white"}]
execute as @e[tag=maxidonis_Entity,tag=phantom_assault_on,tag=!invulnerable_phase] at @s unless entity @e[tag=maxidonis_tp_marker,distance=..700] run tag @s add invulnerable_phase
execute as @e[tag=maxidonis_Entity,tag=phantom_assault_on,tag=invulnerable_phase] at @s unless entity @e[tag=maxidonis_tp_marker,distance=..700] run tag @s remove phantom_assault_on
effect give @e[tag=maxidonis_Entity,tag=invulnerable_phase] resistance 1 4 true
effect give @e[tag=maxidonis_Entity,tag=invulnerable_phase,nbt=!{ActiveEffects:[{Id:10b}]}] regeneration 5 3 true

execute as @e[tag=maxidonis_Entity,tag=invulnerable_phase] at @s run function ampsurv:entity/ally/maxidonis-ip

execute as @e[tag=invul-maxi-path,type=area_effect_cloud] at @s if entity @e[tag=gate,distance=..50] run tp @s ^ ^ ^0.8 facing entity @e[tag=gate,sort=nearest,distance=..100,limit=1] eyes
execute as @e[tag=invul-maxi-path,type=area_effect_cloud] at @s unless entity @e[tag=gate,distance=..50] run tp @s ^ ^ ^0.8 facing entity @p[gamemode=!spectator,sort=furthest,distance=..30] feet
#----------------------------------------------------------------------------------------
