#Old Mage Boss
#execute as @a[scores={boss.battle_tick=..300}] at @s run scoreboard players remove @s boss.battle_tick 1
execute as @a[scores={boss.storage1=308..}] at @s run scoreboard players set @s boss.storage1 0
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!scened] at @s run scoreboard objectives add boss.storage.oldmage dummy
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!scened] at @s run scoreboard players set @a boss.storage.oldmage 0
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!scened] at @s run scoreboard players set @a boss.battle_tick 0
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!scened] at @s run playsound minecraft:boss.revenant.theme record @a[distance=..50] ~ ~ ~ 1 1
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!scened] at @s run tag @s add scened
execute store result score @a boss.storage.oldmage run data get entity @e[tag=oldmage_entity,limit=1,sort=nearest] Health

#Structural Construction
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s run tp @e[tag=oldmage_head,limit=1,sort=nearest] ~ ~ ~ facing entity @p[gamemode=!spectator]
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s run tp @e[tag=oldmage_feet,limit=1,sort=nearest] ~ ~ ~ 
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s run tp @e[tag=oldmage_name,limit=1,sort=nearest] ~ ~2 ~
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s run tp @e[tag=oldmage_entity,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s run tp @s ~ ~ ~
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s run tp @e[tag=align_cd_oldmage,limit=1,sort=nearest] @s

#Align every second
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=align_cd_oldmage,distance=..3] run tp @e[tag=oldmage_feet,limit=1,sort=nearest] ~ ~ ~ facing entity @p[gamemode=!spectator]
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=align_cd_oldmage,distance=..3] run tp @e[tag=oldmage_name,limit=1,sort=nearest] ~ ~2 ~ facing entity @p[gamemode=!spectator]
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=align_cd_oldmage,distance=..3] run tp @s ~ ~ ~ facing entity @p[gamemode=!spectator]
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=align_cd_oldmage,distance=..3] run summon area_effect_cloud ~ ~1 ~ {Duration:20,Tags:["align_cd_oldmage"]}

#Summon if no oldmage part yet
execute as @e[tag=oldmage_entity,tag=!arcane_remnant_proj] at @s unless entity @e[tag=oldmage_body,distance=..10] run summon armor_stand ~ ~ ~ {Tags:["oldmage_body","oldmage_part"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Invisible:0b,Marker:1b,ArmorItems:[{id:"golden_boots",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}},{id:"netherite_leggings",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}},{id:"leather_chestplate",Count:1b,tag:{display:{color:0}}},{}],HandItems:[{id:"netherite_shovel",Count:1b,tag:{CustomModelData:11}},{id:"netherite_shovel",Count:1b,tag:{CustomModelData:12}}],Pose:{Head:[180f,0f,10f]}}
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=oldmage_head,distance=..10] run summon armor_stand ~ ~ ~ {Tags:["oldmage_head","oldmage_part"],Invisible:1b,Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,Marker:1b,ArmorItems:[{},{},{},{id:"player_head",Count:1b,tag:{SkullOwner:{Id:[I;1742301084,235756772,-1669091157,-1193803934],Properties:{textures:[{Value:"e3RleHR1cmVzOntTS0lOOnt1cmw6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYjc2NzI5NzJjZjJiNjg1OTM0YmQxMDJkMzczM2Y0NDQyYjU1NDJlNDEyMTgzMjY2MTQ1MjVmOTJlNjE1NyJ9fX0="}]}},display:{Lore:[]}}}],HandItems:[{},{}]}
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=oldmage_feet,distance=..10] run summon armor_stand ~ ~ ~ {Tags:["oldmage_feet","oldmage_part"],Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Marker:1b,Invisible:1b,ArmorItems:[{id:"golden_boots",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}},{id:"netherite_leggings",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1}},{id:"leather_chestplate",Count:1b,tag:{display:{color:0}}},{}],HandItems:[{},{}],Pose:{LeftLeg:[360f,0f,350f],RightLeg:[0f,0f,10f]}}
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=oldmage_name,distance=..10] run summon armor_stand ~ ~ ~ {CustomNameVisible:1b,Tags:["oldmage_name","oldmage_part"],CustomName:'[{"text":"???","bold":true,"color":"red"}]',Small:1b,Invulnerable:1b,Invisible:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Marker:1b}
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s unless entity @e[tag=oldmage_battle_center] run summon area_effect_cloud ~ ~1 ~ {Duration:2147483647,Tags:["oldmage_battle_center","oldmage_part"]}

execute as @e[tag=oldmage_feet] at @s unless entity @e[tag=oldmage_body,distance=..10] run kill @s
execute as @e[tag=oldmage_head] at @s unless entity @e[tag=oldmage_body,distance=..10] run kill @s
execute as @e[tag=oldmage_name] at @s unless entity @e[tag=oldmage_body,distance=..10] run kill @s
execute as @e[tag=oldmage_battle_center] at @s unless entity @e[tag=oldmage_body,distance=..10] run kill @s

#perma effects
effect give @e[tag=oldmage_entity] invisibility 999999 0 true
effect give @e[tag=oldmage_entity] fire_resistance 999999 0 true
execute as @e[tag=oldmage_head] at @s anchored eyes run particle dust_color_transition 0.8 0.8 0.8 1 0 1 1 ^0.1 ^1.6 ^0.4 0 0 0 0.1 1 force

#Dashing Animation
execute as @e[tag=oldmage_body] at @s if entity @p[scores={boss.battle_tick=..210,boss.storage1=..10},gamemode=!spectator] unless entity @e[tag=oldmage_dash_anim,distance=..3] run summon armor_stand ^ ^ ^-1 {Tags:["oldmage_dash_anim"],Pose:{Head:[15f,0f,0f],RightArm:[10f,46f,20f],LeftArm:[360f,0f,341f],LeftLeg:[360f,0f,350f],RightLeg:[0f,0f,10f]},Invisible:1b,Invulnerable:1b,PersistenceRequired:1b,NoBasePlate:1b,NoGravity:1b,ShowArms:1b,Marker:1b,ArmorItems:[{id:"leather_boots",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1,display:{color:4785234}}},{id:"leather_leggings",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1,display:{color:4785234}}},{id:"leather_chestplate",Count:1b,tag:{Enchantments:[{id:channeling,lvl:1}],HideFlags:1,display:{color:4785234}}},{}],HandItems:[{},{}]}
execute as @e[tag=oldmage_body] at @s if entity @p[scores={boss.battle_tick=..210,boss.storage1=..10},gamemode=!spectator] unless entity @e[tag=oldmage_dash_anim_cd] run summon area_effect_cloud ~ ~ ~ {Duration:20,Tags:["oldmage_dash_anim_cd"]}
execute as @e[tag=oldmage_dash_anim] at @s run particle dust_color_transition 0 0 0 2 0.5 0 0.6 ~ ~1 ~ 0.3 0.5 0.3 1 5 force
execute as @e[tag=oldmage_dash_anim] at @s run tp @s ^ ^ ^0.3 facing entity @e[tag=oldmage_head,limit=1,sort=nearest] feet
execute as @e[tag=oldmage_body] at @s unless entity @e[tag=oldmage_dash_anim_cd] run kill @e[tag=oldmage_dash_anim]
execute as @e[tag=oldmage_dash_anim] at @s run playsound entity.zombie_villager.converted hostile @a[distance=..10] ~ ~ ~ 0.2 2 0
execute as @e[tag=oldmage_dash_anim] at @s unless entity @p[distance=..50] run kill @s

#Attack-locking feature
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s if entity @p[scores={boss.storage1=..10},distance=..3,gamemode=!spectator] run scoreboard players add @p[scores={boss.storage1=..10}] boss.storage1 1
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s if entity @p[scores={boss.storage1=11..},gamemode=!spectator] run scoreboard players add @p[scores={boss.storage1=11..}] boss.storage1 1
execute if entity @p[scores={boss.battle_tick=..210,boss.storage1=..10},gamemode=!spectator] as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s run tp @s ^ ^ ^1.3 facing entity @p[distance=3..]
execute if entity @p[scores={boss.battle_tick=..210,boss.storage1=..10},gamemode=!spectator] as @e[tag=arcane_remnant_proj] at @s run tp @s ^ ^ ^0.5 facing entity @p[distance=3..]

#Attack Animation
execute as @e[tag=oldmage_body,tag=!skill] at @s if entity @p[tag=host,scores={boss.storage1=10..40}] run function ampsurv:boss/oldmage/boss-oldmage-attack

#Reset Pose between attacks
execute as @e[tag=oldmage_body] at @s if entity @p[tag=host,scores={boss.battle_tick=..210,boss.storage1=60..200}] run data modify entity @e[tag=oldmage_head,limit=1,sort=nearest] Pose{} merge value {Head:[15f,0f,0f]}
execute as @e[tag=oldmage_body] at @s if entity @p[tag=host,scores={boss.battle_tick=..210,boss.storage1=60..200}] run data modify entity @e[tag=oldmage_body,limit=1,sort=nearest] Pose{} merge value {Head:[15f,0f,0f],RightArm:[10f,46f,20f],LeftArm:[360f,0f,341f],LeftLeg:[360f,0f,350f],RightLeg:[0f,0f,10f]}
execute as @e[tag=oldmage_body] at @s if entity @p[tag=host,scores={boss.battle_tick=..210,boss.storage1=60..200}] run data modify entity @e[tag=oldmage_feet,limit=1,sort=nearest] Pose{} merge value {LeftLeg:[360f,0f,350f],RightLeg:[0f,0f,10f]}
execute as @e[tag=oldmage_body] at @s if entity @p[tag=host,scores={boss.battle_tick=..210,boss.storage1=60..200}] run data modify entity @e[tag=oldmage_body,tag=!arcane_remnant_proj,limit=1,sort=nearest] Pose{} set value {Head:[180f,0f,0f],RightArm:[10f,46f,20f],LeftArm:[360f,0f,341f],LeftLeg:[360f,0f,350f],RightLeg:[0f,0f,10f]}

#attack effects
execute as @e[tag=oldmage_atk_hitbox] at @s run effect give @e[type=#ally,distance=..3] instant_damage 1 1 true

#Choosing Attack
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!skill] at @s if entity @a[tag=host,scores={boss.battle_tick=207..209}] unless entity @e[tag=choose-path,distance=..50] run summon area_effect_cloud ~ ~ ~ {Duration:20,Tags:["choose-path","choose-atk"]}
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!skill] at @s if entity @a[tag=host,scores={boss.battle_tick=207..209}] unless entity @e[tag=choose-orbs,distance=..50] run summon area_effect_cloud ~ ~ ~ {Duration:20,Tags:["choose-orbs","choose-atk"]}
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!skill] at @s if entity @a[tag=host,scores={boss.battle_tick=210}] run kill @e[tag=choose-atk,sort=random,limit=1]
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!skill] at @s if entity @a[tag=host,scores={boss.battle_tick=211..212}] if entity @e[tag=choose-path,distance=..50] run tag @e[tag=oldmage_body] add mirage_path
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!skill] at @s if entity @a[tag=host,scores={boss.battle_tick=211..212}] if entity @e[tag=choose-orbs,distance=..50] run tag @e[tag=oldmage_body] add mirage_orbs
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!skill] at @s if entity @a[tag=host,scores={boss.battle_tick=211..212}] run tag @e[tag=oldmage_body] add skill

#Skills
execute as @e[tag=oldmage_body,tag=meteoric_shower,type=armor_stand] at @s if entity @p[tag=host,scores={boss.battle_tick=214..}] run function ampsurv:boss/oldmage/boss-oldmage-meteoric
execute as @e[tag=oldmage_body,tag=mirage_path,type=armor_stand] at @s if entity @p[tag=host,scores={boss.battle_tick=214..248}] run function ampsurv:boss/oldmage/boss-oldmage-miragepath
execute as @e[tag=oldmage_body,tag=mirage_path,type=armor_stand] at @s if entity @p[tag=host,scores={boss.battle_tick=214..231}] run function ampsurv:boss/oldmage/boss-oldmage-mirageorbs
execute as @e[tag=oldmage_body,tag=arcane_remnant,type=armor_stand,tag=!arcane_remnant_proj] at @s if entity @p[tag=host,scores={boss.battle_tick=214..251}] run function ampsurv:boss/oldmage/boss-oldmage-remnant

#particle checks
execute if entity @e[tag=mirage_orbs_proj] run function ampsurv:boss/oldmage/boss-oldmage-mirageorbs-effect
execute if entity @e[tag=mirage_path_proj] run function ampsurv:boss/oldmage/boss-oldmage-miragepath-effect
execute if entity @e[tag=meteoric_shower] run function ampsurv:boss/oldmage/boss-oldmage-shower-effect

#Arcane Remnant effects and particles
execute as @e[tag=arcane_remnant_proj] at @s run particle dust_color_transition 0.8 0.8 0.8 1 0 1 1 ~ ~1 ~ 0.4 0.5 0.4 1 10 force
execute as @e[tag=arcane_remnant_proj,tag=!launched] at @s run tp @s ~ ~ ~ facing entity @a[sort=furthest,gamemode=!spectator,limit=1]
execute as @e[tag=arcane_remnant_proj,tag=launched,tag=!active] at @s run tp @s ^ ^ ^1
execute as @e[tag=arcane_remnant_proj,tag=launched,tag=!active] at @s run effect give @e[type=#ally,distance=..3] instant_damage 1 2 true
execute as @e[tag=arcane_remnant_proj,tag=launched,tag=!active] at @s run effect give @e[type=#ally,distance=..3] slowness 3 255 true
execute as @e[tag=arcane_remnant_proj,tag=launched] at @s if entity @e[tag=oldmage_body,distance=15..] run tag @s add active

#Remove Skill Tags
execute as @e[tag=oldmage_body,tag=mirage_path] at @s if entity @p[tag=host,scores={boss.battle_tick=299..300}] run tag @s remove mirage_path
execute as @e[tag=oldmage_body,tag=mirage_orbs] at @s if entity @p[tag=host,scores={boss.battle_tick=299..300}] run tag @s remove mirage_orbs
execute as @e[tag=oldmage_body,tag=arcane_remnant] at @s if entity @p[tag=host,scores={boss.battle_tick=299..300}] run tag @s remove arcane_remnant
execute as @e[tag=oldmage_body,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=599..600}] run tag @s remove meteoric_shower
execute as @e[tag=oldmage_body,tag=skill,tag=!meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=299..300}] run tag @s remove skill
execute as @e[tag=oldmage_body,tag=skill,tag=meteoric_shower] at @s if entity @p[tag=host,scores={boss.battle_tick=599..600}] run tag @s remove skill

execute as @a[scores={boss.storage1=100..200}] at @s run scoreboard players set @s boss.storage1 0
execute as @e[tag=oldmage_body,tag=!meteoric_shower,tag=!arcane_remnant_proj] at @s if entity @p[scores={boss.battle_tick=300..}] run scoreboard players set @a boss.battle_tick 0
execute as @e[tag=oldmage_body,tag=meteoric_shower,tag=!arcane_remnant_proj] at @s if entity @p[scores={boss.battle_tick=600..}] run scoreboard players set @a boss.battle_tick 0

execute as @e[tag=oldmage_body,tag=!75_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..600}] run tag @s add arcane_remnant
execute as @e[tag=oldmage_body,tag=!75_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..600}] run tag @s add skill
execute as @e[tag=oldmage_body,tag=!75_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..600}] run scoreboard players set @a boss.battle_tick 200
execute as @e[tag=oldmage_body,tag=!75_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..600}] run tag @s add 75_percent

execute as @e[tag=oldmage_body,tag=!50_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..400}] run tag @s add meteoric_shower
execute as @e[tag=oldmage_body,tag=!50_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..400}] run tag @s add skill
execute as @e[tag=oldmage_body,tag=!50_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..400}] run scoreboard players set @a boss.battle_tick 200
execute as @e[tag=oldmage_body,tag=!50_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..400}] run tag @s add 50_percent

execute as @e[tag=oldmage_body,tag=!25_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..200}] run tag @s add arcane_remnant
execute as @e[tag=oldmage_body,tag=!25_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..200}] run tag @s add skill
execute as @e[tag=oldmage_body,tag=!25_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..200}] run scoreboard players set @a boss.battle_tick 200
execute as @e[tag=oldmage_body,tag=!25_percent,tag=!arcane_remnant_proj] if entity @p[tag=host,scores={boss.storage.oldmage=..200}] run tag @s add 25_percent

#Defeat
execute as @e[tag=arcane_remnant_proj] at @s unless entity @e[tag=oldmage_entity] run kill @s
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!defeat] at @s unless entity @e[tag=oldmage_entity] run scoreboard players set @a boss.storage1 200
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj,tag=!defeat] at @s unless entity @e[tag=oldmage_entity] run tag @s add defeat
execute as @e[tag=oldmage_body,tag=!arcane_remnant_proj] at @s if entity @p[scores={boss.storage1=200..}] run scoreboard players add @a[scores={boss.storage1=200..}] boss.storage1 1
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=220..221}] run tellraw @a ["",{"text":"< "},{"text":"???","bold":true,"color":"red"},{"text":" > "},{"text":"Hmph.. Perhaps I underestimated you mortals.. Interesting. You might have what it takes... Just... Maybe..","color":"light_purple"},{"text":" "}]
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=280..282}] run data modify entity @s Pose{} merge value {RightArm:[10f,46f,20f],LeftArm:[360f,0f,341f]}
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=284..286}] run data modify entity @s Pose{} merge value {RightArm:[350f,36f,30f],LeftArm:[360f,0f,341f]}
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=288..290}] run data modify entity @s Pose{} merge value {RightArm:[330f,26f,40f],LeftArm:[360f,0f,341f]}
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=292..294}] run data modify entity @s Pose{} merge value {RightArm:[310f,16f,50f],LeftArm:[360f,0f,341f]}
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=296..299}] run data modify entity @s Pose{} merge value {RightArm:[290f,8f,65f],LeftArm:[360f,0f,341f]}
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=300..303}] run data modify entity @s Pose{} merge value {RightArm:[280f,0f,74f],LeftArm:[360f,0f,341f]}
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=304..}] run data modify entity @s Pose{} merge value {RightArm:[0f,0f,63f],LeftArm:[360f,0f,341f]}

execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=210..306}] run particle portal ~ ~1 ~ 0 0 0 3 100 force
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=210..306}] run particle dust_color_transition 0.8 0.8 0.8 2 0 1 1 ^ ^1 ^-1 0.4 1 0.4 3 100 force
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=302..303}] run tellraw @a ["",{"text":"< "},{"text":"???","bold":true,"color":"red"},{"text":" > "},{"text":"Until we meet again, then.","color":"light_purple"},{"text":" "}]
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=302..303}] run scoreboard objectives remove boss.storage.oldmage
execute as @e[tag=oldmage_body,tag=defeat] at @s if entity @p[tag=host,scores={boss.storage1=307}] run kill @e[tag=oldmage_part]