#Jarx
effect give @e[tag=jarx_Entity] invisibility 999999 0 true

execute as @e[tag=jarx_Entity] at @s unless entity @e[tag=jarx_Model,distance=..2] run function crossbow_hero:summon/default
execute as @e[tag=jarx_Entity] at @s unless entity @e[tag=jarx_name,distance=..3] run summon armor_stand ~ ~2 ~ {NoGravity:1b,Marker:1b,Invisible:true,CustomName:'[{"text":"Capital Banneret Jarx","bold":true,"color":"red"}]',CustomNameVisible:1b,Tags:["jarx_name"]}
execute as @e[tag=jarx_Model] at @s run tp @e[tag=jarx_name,limit=1,sort=nearest] ~ ~2 ~

execute as @e[tag=jarx_Entity] at @s if entity @e[type=#enemy,distance=..60] run tp @e[tag=jarx_Model,sort=nearest,limit=1] ^ ^ ^ facing entity @e[type=#enemy,sort=nearest,distance=..60,limit=1]
execute as @e[tag=jarx_Entity] at @s unless entity @e[type=#enemy,distance=..59] run tp @e[tag=jarx_Model,sort=nearest,limit=1] ^ ^ ^ facing entity @p[distance=..20]
execute as @e[tag=jarx_Model] at @s unless entity @e[tag=jarx_Entity,distance=..2] run function crossbow_hero:remove/this

execute as @e[tag=jarx_Model] at @s if entity @e[type=#enemy,distance=..60] run particle electric_spark ~ ~1 ~ 0.4 0.5 0.4 0 1 normal
execute as @e[tag=jarx_Model] at @s if entity @e[type=#enemy,distance=..60] run particle scrape ~ ~1 ~ 0.4 0.5 0.4 0 1 normal
execute as @e[tag=jarx_Entity] at @s unless entity @e[tag=jarx_dd] run summon area_effect_cloud ~ ~ ~ {Duration:2147483647,Tags:["jarx_dd","hero_dd"]}
#reset pose

execute as @e[tag=jarx_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..60] if entity @p[distance=..4,scores={ally.anim_tick=21..30}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Sir Jarx","bold":true,"color":"green"},{"text":"> Watch your surroundings, ","color":"white"},{"selector":"@p","color":"white"},{"text":". One will never know where the enemies can come from.","color":"white"}]
execute as @e[tag=jarx_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..60] if entity @p[distance=..4,scores={ally.anim_tick=11..20}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Sir Jarx","bold":true,"color":"green"},{"text":"> Keep an eye on that guy over there, ","color":"white"},{"selector":"@p","color":"white"},{"text":". I have my suspicions. Just my feeling, though.","color":"white"}]
execute as @e[tag=jarx_Entity,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..60] if entity @p[distance=..4,scores={ally.anim_tick=0..10}] run tellraw @a[distance=..10] ["",{"text":"<","color":"white"},{"text":"Sir Jarx","bold":true,"color":"green"},{"text":"> What do you want, ","color":"white"},{"selector":"@p","color":"white"},{"text":"?","color":"white"}]
execute as @e[tag=jarx_Entity,type=villager,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..60] if entity @p[distance=..4] run tp @s ~ ~ ~ facing entity @p
execute as @e[tag=jarx_Entity,type=villager,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..60] if entity @p[distance=..4] run effect give @s slowness 1 255 true
execute as @e[tag=jarx_Entity,type=villager,tag=!greeted_player] at @s unless entity @e[type=#enemy,distance=..60] if entity @p[distance=..4] run execute as @e[tag=jarx_Model,limit=1,sort=nearest] run function crossbow_hero:animations/cb_greet/next_frame
execute as @e[tag=jarx_Entity] at @s unless entity @e[type=#enemy,distance=..60] if entity @p[distance=..4] run tag @s add greeted_player
execute as @e[tag=jarx_Entity] at @s unless entity @e[type=#enemy,distance=..60] unless entity @p[distance=..10] run tag @s remove greeted_player

#hurt
execute as @e[tag=jarx_Entity,tag=hurt] at @s run playsound entity.generic.hurt neutral @a[distance=..5] ~ ~ ~ 1 1 0
execute as @e[tag=jarx_Entity,tag=hurt] at @s run particle angry_villager ~ ~1.5 ~ 0.3 0.3 0.3 0 3 normal
execute as @e[tag=jarx_Entity,tag=hurt] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=0..10}] ["",{"text":"<","color":"white"},{"text":"Sir Jarx","bold":true,"color":"green"},{"text":"> I'm Spotted!","color":"white"}]
execute as @e[tag=jarx_Entity,tag=hurt] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=11..20}] ["",{"text":"<","color":"white"},{"text":"Sir Jarx","bold":true,"color":"green"},{"text":"> Some help will be appreciated!","color":"white"}]
execute as @e[tag=jarx_Entity,tag=hurt] at @s run tellraw @a[distance=..5,scores={ally.anim_tick=21..30}] ["",{"text":"<","color":"white"},{"text":"Sir Jarx","bold":true,"color":"green"},{"text":"> Futile endeavor!","color":"white"}]

#Attacking
#walking animation
execute as @e[tag=jarx_Entity,type=villager,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s unless entity @e[type=#enemy,distance=..60,limit=1,sort=nearest] run execute as @e[limit=1,sort=nearest,tag=jarx_Model] run function crossbow_hero:animations/cb_walk_idle/next_frame
execute as @e[tag=jarx_Entity,type=villager] at @s if entity @e[type=#enemy,distance=..60,limit=1,sort=nearest] run execute as @e[limit=1,sort=nearest,tag=jarx_Model] run function crossbow_hero:animations/cb_alert_walk/next_frame
execute as @e[tag=jarx_Entity,type=villager,nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=jarx_Model] run function crossbow_hero:animations/cb_attack_1/pause

execute as @e[tag=jarx_Entity,type=villager,nbt={Motion:[0.0d,0.0d,0.0d]}] at @s unless entity @e[type=#enemy,distance=..60,limit=1,sort=nearest] run execute as @e[limit=1,sort=nearest,tag=jarx_Model] run function crossbow_hero:animations/idle/next_frame
execute as @e[tag=jarx_Entity,type=villager,nbt={Motion:[0.0d,0.0d,0.0d]}] at @s run execute as @e[limit=1,sort=nearest,tag=jarx_Model] run function crossbow_hero:animations/walk_idle/pause

execute as @e[tag=jarx_Entity,type=villager] at @s if entity @e[tag=jarx_proj,distance=..3] run tp @s ~ ~ ~ facing entity @e[type=#enemy,distance=..60,limit=1,sort=nearest]
execute as @e[tag=jarx_Entity,type=villager] at @s run execute as @e[limit=1,sort=nearest,tag=jarx_Model] at @s if entity @e[tag=jarx_proj,distance=..3] run function crossbow_hero:animations/cb_attack_1/play

#Attack particles and effects
execute as @e[tag=jarx_Model] at @s unless entity @e[tag=jarx_proj,distance=..60] if entity @e[type=#enemy,distance=..60] positioned ~ ~1.3 ~ anchored eyes run summon area_effect_cloud ~ ~ ~ {Duration:30,Tags:["jarx_proj"]}
execute as @e[tag=jarx_proj,tag=!targetted] at @s if entity @e[tag=jarx_Model,distance=..5] if entity @e[type=#enemy,distance=..60] run tp @s ^ ^ ^0.1 facing entity @e[type=#enemy,limit=1,sort=nearest] eyes
execute as @e[tag=jarx_proj,tag=!targetted] at @s if entity @e[tag=jarx_Model,distance=..5] if entity @e[type=#enemy,distance=..60] run tag @s add targetted
execute as @e[tag=jarx_Model] at @s if entity @e[tag=jarx_proj,distance=..3] if entity @e[type=#enemy,distance=..60] run playsound item.crossbow.shoot neutral @a[distance=..10] ~ ~ ~ 1 1 0.1
execute as @e[tag=jarx_Model] at @s if entity @e[tag=jarx_proj,distance=..3] if entity @e[type=#enemy,distance=..60] run playsound entity.lightning_bolt.thunder neutral @a[distance=..10] ~ ~ ~ 0.3 2 0.1

execute as @e[tag=jarx_proj] at @s run particle firework ~ ~ ~ 0 0 0 0 1 normal
execute as @e[tag=jarx_proj] at @s run particle electric_spark ~ ~ ~ 0.1 0.1 0.1 0.5 10 force
execute as @e[tag=jarx_proj] at @s run tp @s ^ ^ ^2
execute as @e[tag=jarx_proj] at @s run effect give @e[type=#enemy,type=!#undead,distance=..2.1] instant_damage 1 0 true
execute as @e[tag=jarx_proj] at @s run effect give @e[type=#undead,distance=..2.1] instant_health 1 0 true
execute as @e[tag=jarx_proj] at @s run tag @e[type=#enemy,distance=..2.1] add armor_reduce_10
execute as @e[tag=jarx_proj] at @s if entity @e[type=#enemy,distance=..2] run tag @s add hit_enemy
execute as @e[tag=jarx_proj,tag=hit_enemy] at @s run kill @s
execute at @e[tag=armor_reduce_10] run particle scrape ~ ~1 ~ 0.2 0.5 0.2 0.1 1 normal
